'''
Created on 28/mar/2010
'''
import pygame,data_loader,os,random,math
from pygame.locals import*
height=600
width=800
clock=pygame.time.Clock()
class thing(pygame.sprite.Sprite):
    def __init__(self,image,x,y,winning=0):
        pygame.sprite.Sprite.__init__(self) 
        self.x=x
        self.y=y
#       self.image=data_loader.load_image(image,(255,255,255))###load image into level!
        self.image=image
        self.rect=self.image.get_rect(center=(self.x,self.y))
        self.wiinning=winning
#        if self.winning:
#            winnner.add(self)
#        else:
#            things.add(self)
    def move(self,x_amount,y_amount): 
        self.x+=x_amount
        self.y+=y_amount
        if not 0<self.x<width:
            self.x-=x_amount
        if not 0<self.y<height:
            self.y-=y_amount
        self.rect=self.image.get_rect(center=(self.x,self.y)) 
class timer():
    def __init__(self,minutes,seconds):
        self.clock=clock
        self.milliseconds=0
        self.seconds=0
        self.minutes=0
        self.startminutes=minutes
        self.startseconds=seconds
        self.minutesleft=self.startminutes
        self.secondsleft=self.startseconds
        self.going=1   
        self.text=""
        self.readytext=None
        self.textrect=None        
    def update (self):
        if self.going:
            #self.clock.tick()
            self.milliseconds+=self.clock.tick()#self.clock.get_time ()
            self.seconds=self.milliseconds/1000
            self.minutes=self.seconds/60
            self.seconds%=60
            self.minutesleft=self.startminutes-self.minutes
            self.secondsleft=self.startseconds-self.seconds
            if self.minutesleft==0 and self.secondsleft==0:
                self.going=0
    def make_text(self,color1,color2,dimension,font):
        if self.secondsleft<10:
            self.text="time: "+str(self.minutesleft)+": 0"+str(self.secondsleft)
            color=color1
        else:
            self.text="time: "+str(self.minutesleft)+": "+str(self.secondsleft)
            color=color2   
        place=os.path.join("fonts",font)
        loadedfont= pygame.font.Font(place,dimension)
        self.readytext=loadedfont.render(self.text,0,color,(255,255,255))
        self.readytext.set_colorkey((255,255,255))
        self.textrect=self.readytext.get_rect(topleft=(0,0))
        self.textrect.width=10000# to be checked
class level():
    def __init__(self,number,thingsnumber,winnerimage,imagelist,sound,minutes,seconds,bgimage,x_speed,y_speed,x_fase,y_fase,x_angle,y_angle): 
        self.winner=pygame.sprite.GroupSingle()
        self.grabbed=pygame.sprite.GroupSingle()
        self.things=pygame.sprite.pygame.sprite.OrderedUpdates()#sprites added first are drawn on top and added to sprites in order?  
        self.number=number
        self.thingsnumber=thingsnumber
        self.imagelist=[]
        self.winnerimage=data_loader.load_image(winnerimage,(255,255,255)) 
        for image in imagelist:
            self.imagelist.append(data_loader.load_image(image,(255,255,255))) 
        for i in range(thingsnumber):
            self.things.add(thing(random.choice(self.imagelist),random.randint(0,width),random.randint(0,height)))     
        self.winner.add(thing(self.winnerimage,random.randint(0,width),random.randint(0,height)))
        while  pygame.sprite.spritecollide(self.winner.sprite, self.things,0)==[]:
                self.winner.add(thing(self.winnerimage,random.randint(0,width),random.randint(0,height)))       
        self.timer=timer(minutes,seconds)      
        self.bgimage=data_loader.load_image(bgimage,(255,255,255)) 
        self.bgx=-20
        self.bgy=-20
        self.minimum=-20
        self.maximum=0
        self.bgrect=self.bgimage.get_rect(topleft=(self.bgx,self.bgy))
        self.x_move=0
        self.y_move=0
        self.x_speed=x_speed
        self.y_speed=y_speed
        self.x_fase=x_fase
        self.y_fase=y_fase
        self.x_angle=x_angle
        self.y_angle=y_angle
        self.sound=data_loader.load_sound(sound)
    def wibble(self):
        self.x_move=self.x_speed*math.cos(self.timer.secondsleft*self.x_angle+self.x_fase)
        self.y_move=self.y_speed*math.sin(self.timer.secondsleft*self.y_angle+self.y_fase)
        if self.minimum<self.bgx+self.x_move<self.maximum:
            self.bgx+=self.x_move
        if self.minimum<self.bgy+self.y_move<self.maximum:
            self.bgy+=self.y_move
        self.bgrect=self.bgimage.get_rect(topleft=(self.bgx,self.bgy))
        for i in self.winner.sprites()+self.things.sprites():
            i.move(self.x_move,self.y_move)
    def update(self):
        self.timer.update()
        self.timer.make_text((255,0,0), (0,255,255), 50, "old.ttf")
        self.wibble()
                            
                                                
        
                    
            
        
                         
            